*! version 1.1.1  24jan2000
program define _rmdcoll, rclass
	version 6.0

	syntax varlist(ts) [in] [if] [fw iw aw pw]  [, noCOLlin noConstant ]
	marksample touse
					/* weights */
	if "`weight'" ~= "" {
		tempvar w
		qui gen double `w'  `exp' if `touse'
		local wgt [`weight'=`w']
	}
	else local wgt

	gettoken yvar xvars: varlist
	if "`xvars'" == "" {
		exit
	} 

	tempname hldname c b
	local flag 0
	if "`e(cmd)'" != "" {
		est hold `hldname'
		local flag 1	
	}

					/* nocollin option */
	if "`collin'" =="" {
		_rmcoll `xvars' `wgt' if `touse', `constant' 
		local xvars "`r(varlist)'"
		return local varlist "`xvars'" 
	}

				/* y xs of full rank? */ 
	qui _rmcoll `yvar' `xvars' `wgt' if `touse', `constant'
       	if "`yvar' `xvars'" == "`r(varlist)'" {
		if `flag' {
			est unhold `hldname' 
		}
		exit
	}
	else {
					/* select the largest abs value */

		qui reg `yvar' `xvars' `wgt' if `touse', `constant' 
		mat `b'=get(_b)
		local i 2 
		local cmax abs(`b'[1,1])	
		scalar `c'=colsof(`b')
	 	while `i' < = `c' {
			if abs(`b'[1,`i']) > `cmax' {
				local cmax abs(`b'[1,`i'])
			}
			local i = `i'+1
		}

					/* get the varnames */

		local names: colnames `b'
		tokenize `names'
		local i 1
		while "``i''" ~= ""{
			if  abs(`b'[1,`i']) > `cmax' * 1e-5 {
				local cnames `cnames' ``i''
			}
			local i =`i'+1
			mac shift
		}
		if `flag'== 1  {
			est unhold `hldname'
		}
					/* display error message , exit */
		di in red "`yvar' collinear with `cnames'"
 		exit 459	
	}
end
		
