*! version 2.3.7 24apr2000
* touched by roc 

program define hausman, rclass
	version 6

	syntax [, Alleqs CLEAR Constant CURrent(string) Less More	/*
		*/ Prior(string) Save SIGMAMore SIGMALess 		/*
		*/ SKipeqs(string) SYMINV EQuations(string) ]

	if "`save'" != "" {
		syntax [, Save]
		priorest, save
		exit
	}
	if "`clear'" != "" {
		syntax [, CLEAR]
		priorest, clear
		exit
	}

	syntax [, Alleqs Constant CURrent(string) Less More Prior(string) /*
		*/ SIGMAMore SIGMALess SKipeqs(string) SYMINV		/*
		*/ EQuations(string) ] 


	if "`equatio'" != "" {
		local alleqs ""
		local skipeqs ""
 		Mlist "`equatio'"
		local est1 `s(opt1)'
		local est2 `s(opt2)'
	}

	if "`less'"!="" { 
		if "`more'"!="" {
			di in red "may not specify both -less- and -more-"
			exit 198
		}
		local reverse "reverse"
	}

	priorest, check

						/* get order of test right */
	tempname b1 V1 b2 V2 res Vtmp rank chi2
	if "`prior'" == "" { local prior "Prior" }
	if "`current'" == "" { local current "Current" }
	if "`reverse'"=="" { 
		mat `b1' = S_LAST_b
		mat `V1' = S_LAST_V
		local sigma1 = $S_LAST_s
		mat `b2' = get(_b)
		mat `V2' = get(VCE)
		if "`e(sigma)'" != "" { local sigma2 "`e(sigma)'" }
		else { local sigma2 "`e(rmse)'" }

		local prior1 " previously"
		local cmd1 "$S_LAST_c"
		local cmd2 "`e(cmd)'"
	}
	else { 
		mat `b2' = S_LAST_b
		mat `V2' = S_LAST_V
		local sigma2 = $S_LAST_s
		mat `b1' = get(_b)
		mat `V1' = get(VCE)
		local tmp "`est1'"
		local est1 "`est2'"
		local est2 "`tmp'"
		if "`e(sigma)'" != "" { local sigma1 "`e(sigma)'" }
		else local sigma1 "`e(rmse)'"

		local hold `prior'
		local prior `current'
		local current `hold'
		local prior2 " previously"
		local cmd2 "$S_LAST_c"
		local cmd1 "`e(cmd)'"
	}
	Strik0 `b1' `V1'
	Strik0 `b2' `V2'

	if "`skipeqs'" != "" {
		SkipEqs row `b1' "`skipeqs'"
		SkipEqs mat `V1' "`skipeqs'"
		SkipEqs row `b2' "`skipeqs'"
		SkipEqs mat `V2' "`skipeqs'"
	}
	else if "`equatio'" != "" {
			Select `b1' `V1' "`est1'"
			Select `b2' `V2' "`est2'"
	} 
	else if "`alleqs'" == "" {
			Get1steq row `b1'
			Get1steq mat `V1'
			Get1steq row `b2'
			Get1steq mat `V2'
	}

	if "`constan'"=="" {
		Rmcons `b1'
		Rmcons `V1'
		Rmcons `b2'
		Rmcons `V2'
	}

	if "`sigmamo'" != "" | "`sigmale'" != "" {
		if "`sigma1'" == "" | "`sigma2'" == "" {
			di in red "Estimators do not save e(sigma) or e(rmse),"
			di in red "sigma option not allowed"
			exit 198
		}
		if "`sigmamo'" != "" { 
			matrix `V1' = `sigma2'^2 * `V1' / `sigma1'^2 
		}
		else 	matrix `V2' = `sigma1'^2 * `V2' / `sigma2'^2 
	}
	
	capture matconf `b1' `V1' `b2' `V2'
	if _rc {
di in red "no common coefficients names (eq:coef)" 
di in red "specify -equations(matchlist)-" /*
	*/ " for the problem of different equation names. "
			exit 498
	}
	matrix `V2' = `V1' - `V2'

	di _n in gr _col(13) "---- Coefficients ----" _n /* 
		*/ _col(10) "|" _col(17) "(b)" _col(30) "(B)"	/*
		*/ _col(45) "(b-B)"				/*
		*/ _col(53) "sqrt(diag(V_b-V_B))" _n		/*
		*/ _col(10) "|" _col(13) %~12s `"`prior'"' 	/*
		*/ _col(26) %~12s `"`current'"'			/*
		*/ _col(42) "Difference" _col(60) "S.E." _n	/*
		*/ "---------+" _dup(61) "-"

	local eqnames : coleq `b1'
	DropDup uniqeq : "`eqnames'"
	local numeq : word count `uniqeq'

	local names : colnames `b1'
	local omit 0
	tokenize `names'
	local i 1 
	while `i' <= colsof(`b1') {
		if `numeq' > 1 {
			local eq : word `i' of `eqnames'
			if "`eq'" != "`holdeq'" {
				if `i' != 1 {
					di in gr "---------+" _dup(61) "-"
				}
				di in ye "`eq'" _col(10) in gr "|"
				local holdeq `eq'
			}
		}
		local skip = 8 - length("``i''")
		di in gr _skip(`skip') "``i'' |  " in ye /* 
			*/ %9.0g `b1'[1,`i'] "    " /* 
			*/ %9.0g `b2'[1,`i'] _skip(8) /* 
			*/ %9.0g `b1'[1,`i'] - `b2'[1,`i'] _skip(4) /*
			*/ %9.0g sqrt(`V2'[`i',`i']) _c
		if "`syminv'" != "" & `V2'[`i',`i']==0 { 
			di "  (omitted)" _c
			local omit = `omit' + 1 
		}
		di
		local i = `i' + 1
	}
	di in gr "---------+" _dup(61) "-"
	di in gr _col(13) /*
*/ "b = less efficient estimates obtained`prior1' from `cmd1'."
	di in gr _col(13) /*
*/ "B = fully efficient estimates obtained`prior2' from `cmd2'."

	matrix `b2' = `b2' - `b1'
	matrix `Vtmp' = `V2'
	MatGinv `V2' `rank' : `Vtmp' `syminv'

	matrix `res' = `b2' * `V2' * `b2''
	scalar `chi2' = `res'[1,1]

	di _n in gr "Test:  Ho:  difference in coefficients not systematic"

	local n = colsof(`b2')

	di _n in gr _col(13) "chi2(" in ye %3.0f `rank' in gr /*
		*/ ") = (b-B)'[(V_b-V_B)^(-1)](b-B)" 

	if `chi2'>=0 { 
		di in gr /* 
		*/ _col(23) "=" in ye %9.2f `chi2' _n /*
		*/ in gr _col(13) "Prob>chi2 = " /*
		*/ in ye %10.4f chiprob(`rank', `chi2')
	}
	else {
		di in gr _col(23) "=" in ye %9.2f `chi2' in gr /* 
		*/ _col(37) "chi2<0 ==> model estimated on these" _n /*
		*/ _col(37) "data fails to meet the asymptotic" _n /*
		*/ _col(37) "assumptions of the Hausman test"
	}
	ret scalar p = chiprob(`rank', `chi2')
	ret scalar df = `rank'
	ret scalar chi2 = `res'[1,1]
end


program define Get1steq /* row|mat matname */
	args type m
	local eq : coleq(`m')
	local eq : word 1 of `eq'
	if "`type'"=="row" {
		mat `m' = `m'[1,"`eq':"]
		/* mat coleq `m' = _: */
	}
	else {
		mat `m' = `m'["`eq':", "`eq':"]
		/* mat coleq `m' = _: */
		/* mat roweq `m' = _: */
	}
end


program define SkipEqs /* row|mat matname eq_skip_list */
	args type M skiplst

	local eqnames : coleq `M'
	DropDup eqnames : "`eqnames'"

	tempname T
	tokenize `eqnames'
	local curk 0
	local i 1
	while "``i''" != "" {
		local unused  : subinstr local skiplst "``i''" "``i''" , /*
			*/ word count(local count)
		if `count' == 0 {
			if "`type'" == "mat" {
				if `curk' > 0 {
				mat `T' =  nullmat(`T')		    ,	/*
					*/ `M'[1..`curk', "``i'':"] \	/*
					*/ `M'["``i'':", 1..`curk'] ,	/*
					*/ `M'["``i'':", "``i'':"]
			    }
			    else {
				mat `T' = `M'["``i'':", "``i'':"]
			    }

				local curk = colsof(`T')
			}
			else {
				mat `T' = nullmat(`T') , `M'[1, "``i'':"]
			}
		}
		local i = `i' + 1
	}

	mat `M' = `T' 
end

program define Mlist, sclass
	sreturn clear
	args list 
	gettoken thing1 0 : list , parse(":")
	while "`thing1'" != "" {
		IsThing integer number `thing1'
		gettoken colon 0 : 0 , parse(" ,:")
		IsToken : `colon' 
		gettoken thing2 0 : 0, parse(" ,")
		IsThing integer number `thing2'
		local opt1 "`opt1' `thing1'"
		local opt2 "`opt2' `thing2'"
		gettoken thing1 0 : 0, parse(",:")
		if "`thing1'"== "," {
			gettoken thing1 0 : 0, parse(":") 
		}
	}
	sreturn local opt1  "`opt1'"
	sreturn local opt2  "`opt2'"	
end

program define IsToken
	args exp opt
	if "`exp'" != "`opt'"	{
		dis in red "`opt' found where `exp' expected"
		exit 198
	}
end 

program define IsThing
	args type1 type2  opt
	confirm `type1' `type2' `opt'
end

		
program define Select       /* b V  select_list */
/* Select equations to be included in the matrix*/
	args b V  list
	tempname T
					/* selection */	
	local enames : coleq `b'
	DropDup senames : "`enames'"
	local num : word count `senames'
	if `num' == 0 {
		local i 1
		while `i' <= colsof(`b') {
			local neweq "`neweq' comp1"
			local i = `i' + 1
		}
	} 
	else {
		tokenize "`senames'"
		local i 1
		while `i' <= `num' {
			local junk : subinstr local list "`i'" "`i'", /*
				*/ word count(local count)
			if `count' == 0 {
				SkipEqs row `b' "``i''"
				SkipEqs mat `V' "``i''"
			}
			local i = `i' + 1
		}
	}						

					/* equation rename */
	if "`neweq'" == "" {
		local enames : coleq `b'
	}
	else local enames "`neweq'"
	local cnames : colnames `b'
	local i 1
	local j 0 
	tokenize "`enames'"
	while `i' <= colsof(`b') {
		local col : word `i' of `cnames'
	   	if "``i''" != "`old'" {
			local j = `j' + 1
		        local old "``i''"
		} 
		local newname "`newname' comp`j':`col'"
		local i = `i' + 1
	}		 			
	mat colnames `b' = `newname'
	mat colnames `V' = `newname'
	mat rownames `V' = `newname'
end

/*  Drop all duplicate tokens from list */
program define DropDup   /* <newlist> : <list> */
	args	    newlist	/*  name of macro to store new list
		*/  colon	/*  ":"
		*/  list	/*  list with possible duplicates */

	gettoken token list : list
	while "`token'" != "" {
		local fixlist `fixlist' `token'
		local list : subinstr local list "`token'" "", word all
		gettoken token list : list
	}

	c_local `newlist' `fixlist'
end


program define Rmcons /* matname */
	args m 

	local names : colnames `m'

	local ct : word count `names'
	tokenize `names'
	local i 1
	local strkcol 1
	while "``i''" != "" {
		if "``i''" == "_cons" { 
			if `i' == `ct' & `strkcol' == 1 {
			di in red "no common coefficients names (eq:coef)," /*
				*/ " nothing to test"
				exit 498
			}
			else {
				matstrik `m' `strkcol' 
				local strkcol = `strkcol' - 1
			}
		}
		local i = `i' + 1
		local strkcol = `strkcol' + 1
	}

end


/* -- begin matconf */
 *! version 1.0.0  23 May 1998
program define matconf /* b1 V1 b2 V2 */
	version 6
	args b1 V1 b2 V2

	tempname e wrk map

	local nam1 : colfullnames `b1'
	local nam2 : colfullnames `b2'

				/* make `e' = (1, 2, 3, ...)	*/
	local n2 = colsof(`b2')
	mat `e' = `b2'
	local i 1 
	while `i' <= `n2' { 
		mat `e'[1,`i'] = `i' 
		local i = `i' + 1
	}

	local n1 = colsof(`b1')
	local i 1 
	while `i' <= `n1' { 
		local name : word `i' of `nam1'
		capture mat `wrk' = `e'[1,`"`name'"']
		if _rc { 
			if _rc != 111 { error _rc } 
			if `n1'==1 { 
				mat drop `b1' `V1' `b2' `V2'
				exit 111
			}
			matstrik `b1' `i'
			matstrik `V1' `i'
			local nam1 : colfullnames `b1'
			local n1 = `n1' - 1 
		}
		else {
			mat `map' = nullmat(`map'), `wrk'
			local i = `i' + 1 
		}
	}

	/* we know `n1' >= 1 */

	tempname newb2 newV2

	mat `newb2' = `b1'	/* just to dcl and obtain names */
	mat `newV2' = `V1'

	local i 1 
	while `i' <= `n1' { 
		local ip = `map'[1,`i']
		mat `newb2'[1,`i'] = `b2'[1,`ip']
		local j 1
		while `j' <= `n1' { 
			mat `newV2'[`i',`j'] = `V2'[`ip',`map'[1,`j']]
			mat `newV2'[`j',`i'] = `newV2'[`i',`j']
			local j = `j' + 1
		}
		local i = `i' + 1 
	}
	mat `b2' = `newb2'
	mat `V2' = `newV2'
end
/* -- end matconf */


/* -- begin MatGinv */
/* adapted from Jeroen Weesie/ICS  STB-39 dm49 */

program define MatGinv
	args	    invmat	/* matrix name to hold inverted matrix
		*/  rank	/* scalar name to hold rank of matrix
		*/  colon	/* ":"
		*/  A		/* name of matrix to be inverted (mat be invmat)
		*/  syminv	/* "" or "syminv" for use syminv
		*/  tol		/* tolerence or "" */
      
        tempname At U W V Wmax

	if "`syminv'" != "" {		/* Just a syminv requested */
		tempname At
		mat `invmat' = syminv(`A')
		matrix `At' = colsof(`A') - diag0cnt(`invmat')
		scalar `rank' = `At'[1,1]
		exit
	}

        local nrA = rowsof(`A')
        local ncA = colsof(`A')

					/* get rank */
	matrix `At' = colsof(`A') - diag0cnt(syminv(`A'))
	local srank = `At'[1,1]

					/* singular value decomposition */
        if `nrA' < `ncA' {
                mat `At' = `A''
                mat svd `V' `W' `U' = `At''
        } 
        else {
                mat svd `U' `W' `V' = `A'
        }                

					/* tolerance for inverting the 
					   diagonal elements of W */
        if "`tol'" == "" {
                		/* max of singular values */
                local nc = colsof(`W')
                scalar `Wmax' = 0
                local i 1
                while `i' <= `nc' {
                        if (`W'[1,`i'] > `Wmax') { 
                                scalar `Wmax' = `W'[1,`i'] 
                        }
                        local i = `i' + 1
                }
                tempname tol
                scalar `tol' = `Wmax' * `nc' * 1.0e-9 
        }

					/* invert the elements of W */
        local i 1
        local rnk 0
        while `i' <= colsof(`W') {
                if `W'[1,`i'] > `tol' { 
                        mat `W'[1,`i'] = 1/(`W'[1,`i'])
                        local rnk = `rnk' + 1
                }
                else { 
                        mat `W'[1,`i'] = 0
                }
                local i = `i' + 1
        }           

					/* produce InvA */
        if `rnk' == 0 {
                mat `invmat' = J(`ncA',`nrA',0)
        }
        else    mat `invmat' = `V' * diag(`W') * `U''
 
        if "`rank'" != "" { 
		if "`rnksym'" != "" {
			scalar `rank' = `srank' 
		}
		else    scalar `rank' = `rnk'
	}
end
/* -- end MatGinv */

/*
	MatGinv A, [ ginv(Ai) rank(r) tol(#)]

	computes the Moore-Penrose inverse Ai of A, i.e., the unqiue 
	matrix that satisfies the 4 conditions
	 (1)  Ai*A*Ai = Ai
	 (2)  A*Ai*A  = A
	 (3)  Ai*Ai'  is a projection on the null space of A
	 (4)  Ai'*Ai  is a projection on the image of A

	if A is invertible, Ai = inverse(A)

	if A is n by m, Ai = m by n

	If A is a matrix of zeros, the MP-inverse is all-zeroes also.

	The first two requirements, (1) and (2) above, have been checked 
                using tough matrices from ./sim/sim_mcfad7 and the
                requirements are met to reasonable accuracy.

*/
/* -- end MatGinv */


program define Strik0 
	args b V
	while diag0cnt(`V') { 
		if colsof(`V')==1 { 
			di in red "nothing to test"
			exit 498
		}
		Find0 `V'
		local i `r(i)'
		matstrik `b' `i'
		matstrik `V' `i'
	}
end
		
program define Find0, rclass
	args V
	local i 1 
	while `V'[`i',`i'] != 0 { 
		local i = `i' + 1
	}
	ret local i `i'
end

