*! version 1.0.0  09mar1999
program define nbreg_al
	version 6.0
	args todo b lnf g H g1 g2

/* Calculate the log-likelihood. */

	tempvar m
	tempname lndelta delta lnoned

	mleval `m' = `b', eq(1)
	mleval `lndelta' = `b', eq(2) scalar

	local bound -30
	if `lndelta' < `bound' { scalar `lndelta' = `bound' }
	scalar `delta' = exp(`lndelta')
	scalar `lnoned' = ln(1+`delta')

	qui replace `m' = exp(`m'-`lndelta')

	local y "$ML_y1"

	mlsum `lnf' = lngamma(`y'+`m') - lngamma(`y'+1) - lngamma(`m') /*
	*/ + `lndelta'*`y' - (`y'+`m')*`lnoned'

	if `todo' == 0 | `lnf'==. { exit }

/* Calculate the scores and gradient. */

	qui replace `g1' = `m'*(digamma(`y'+`m') - digamma(`m') - `lnoned') /*
	*/ if $ML_samp

	qui replace `g2' = `y' - (`y'+`m')*`delta'/(1+`delta') - `g1' /*
	*/ if $ML_samp

	tempname d1 d2
	mlvecsum `lnf' `d1' = `g1', eq(1)
	mlvecsum `lnf' `d2' = `g2', eq(2)
	matrix `g' = (`d1',`d2')

	if `todo' == 1 | `lnf'==. { exit }

/* Calculate negative hessian. */

	tempname d11 d12 d22
	tempvar dd

	qui gen double `dd' = -`m'*(digamma(`y'+`m') - digamma(`m') /*
	*/  - `lnoned' + `m'*(trigamma(`y'+`m') - trigamma(`m'))) if $ML_samp

	mlmatsum `lnf' `d11' = `dd', eq(1)

	mlmatsum `lnf' `d12' = `m'*`delta'/(1+`delta') - `dd', eq(1,2)

	mlmatsum `lnf' `d22' = `delta'*(`y'-`m'*(1+2*`delta')) /*
	*/ /(1+`delta')^2 + `dd', eq(2)

	matrix `H' = (`d11',`d12' \ `d12'',`d22')
end
