*! version 6.0.1  19sep2000
program define stcox, eclass
	version 6.0

	if _caller()<6 {
		ztcox_5 `0'
		exit
	}

	if replay() {
		syntax [, ESTImate noHR * ]
		if `"`estimat'"'=="" {
			if `"`e(cmd2)'"' != "stcox" {
				error 301 
			}
			local hr = cond(`"`hr'"'=="", "hr", "")

			local h = cond(`"`e(strata)'"'=="", /*
				*/ "Cox regression", /*
				*/ "Stratified Cox regr.")


			local h1="no ties"
			if "`e(ties)'"=="breslow" {
				local h1="Breslow method for ties" 
			}
			else if "`e(ties)'"=="efron" { 
				local h1="Efron method for ties"
			}
			else if "`e(ties)'"=="partial" { 
				local h1="exact partial likelihood"
			}
			else if "`e(ties)'"=="marginal" { 
				local h1="exact marginal likelihood" 
			}

			di _n in gr `"`h' -- `h1'"'
			st_hcd
			di
			cox, nohead `hr' `options'
			exit
		}
	}
	st_is 2 analysis

	syntax [varlist(default=none)] [if] [in] [,CLuster(string) /*
	*/ CMD ESTImate noHR Level(integer $S_level) Robust noSHow /*
	*/ BRESlow EFRon EXACTM EXACTP * ]

	local id : char _dta[st_id]
	local w  : char _dta[st_w]
	local wt : char _dta[st_wt]
	local t0 `"t0(_t0)"'
	local d `"dead(_d)"'

	tempvar touse 
	st_smpl `touse' `"`if'"' `"`in'"' `"`cluster'"'
	markout `touse' `varlist'

	if `"`wt'"'=="pweight" {
		local robust `"robust"'
	}

	if `"`robust'"'!="" & `"`cluster'"'=="" & `"`id'"'!="" {
		local cluster `"`id'"'
	}
	if `"`cluster'"'!="" {
		local cluster `"cluster(`cluster')"'
	}

	st_show `show'

	if `"`cmd'"'!="" {
		di _n in gr "-> cox _t `varlist' `w' `if' `in'," _c
	 	di in gr " `robust' `cluster' `t0' `hr' `d' `options' " _c
		di in gr " `breslow' `efron' `exactm' `exactp' "
		exit
	}

	cox _t `varlist' `w' if `touse', `robust' `cluster' /*
	*/ `t0' `d' `options' nocoef `breslow' `efron' `exactm' `exactp'

	if e(N)==0 | e(N)==. { exit 2001 }
	/* inherits e() stuff from -cox- */

	SaveOpt, `options' 

	global S_E_ll = e(ll)			/* double save */
	global S_E_chi2 = e(chi2)		/* double save */
	global S_E_mdf = e(df_m)		/* double save */


	st_hc `touse'

	est local predict stcox_p
	est local cmd2 "stcox"
	global S_E_cmd2 "stcox"		/* double save */

	stcox, `hr' level(`level')
end


program define SaveOpt, eclass
	syntax [, MGale(string) BASEHazard(string) BASEChazard(string) /*
		*/ BASESurv(string) SCHoenfeld(string) /*
		*/ SCAledsch(string) ESR(string) * ]
	est local mgale "`mgale'"
	est local baseh "`basehazard'"
	est local basech "`basechazard'"
	est local bases "`basesurv'"

	SaveNm vl_sch "`schoenf'" "Schoenfeld"
	SaveNm vl_ssc "`scaleds'" "scaled Schoenfeld"
	SaveNm vl_esr "`esr'"	  "efficient score"

	if "`mgale'" != "" { label var `mgale' "martingale" }
	if "`basehaz'" != "" { label var `basehazard' "baseline hazard" }
	if "`basesur'" != "" { label var `basesurv' "baseline survivor" }
	if "`basecha'" != "" { 
		label var `basechazard' "cumulative baseline hazard" 
	}
end

program define SaveNm, eclass
	args name base lname 

	if "`base'" == "" { exit }

	tempname b
	mat `b' = get(_b)
	local p = colsof(`b')
	local names : colnames(`b')

	local j = index("`base'","*")
	if `j' {
		local base = substr("`base'",1,`j'-1)
		local i 1
		while `i' <= `p' {
			local iname : word `i' of `names'
			label var `base'`i' "`lname' - `iname'"
			local list `list' `base'`i'
			local i = `i'+1
		}
	}
	else {
		tokenize `base'
		local i 1
		while `i' <= `p' {
			local iname : word `i' of `names'
			label var ``i'' "`lname' - `iname'"
			local list `list' ``i''
			local i = `i'+1
		}
	}
	est local `name' `list'
end
