*! version 2.0.2  09feb1999
program define svymlog
	version 6
	args flag query

	if "`flag'"!="0" {
		svy_est svymlog `0'
		exit
	}
	if "`query'"=="syntax" {
		Syntax
		exit
	}
	if "`query'"=="how_many_scores" {
		HowMany
		exit
	}
	if "`query'"=="save" {
		Save
		exit
	}
	if "`query'"=="scores" {

	/* Save results from mlogit. */

	       	global S_VYibas  = e(ibasecat)
		scalar $S_VYtmp1 = e(basecat)
		matrix $S_VYtmp2 = e(cat)
		exit
	}
	if "`query'"=="footnote" {
		Footnote
		exit
	}

	di in red "0 invalid name"
	exit 198
end

program define Syntax, sclass
	sret clear
	sret local title    "Survey multinomial logistic regression"
	sret local cmd      "mlogit"
	sret local k_depvar "1"
	sret local dopts    "RRr"  /* special display option */
	sret local okopts   "Basecategory(passthru) Constraints(passthru)"
				   /* additional allowed options */
	sret local mlopts   "yes"  /* ml options are allowed */
end

program define HowMany, rclass
	qui tab $S_VYdepv if $S_VYsub
	global S_VYncat = r(r)         /* # of categories */
	ret scalar k_scores = r(r) - 1 /* # of score indexes */
	ret scalar cmdcando = 1        /* mlogit can compute them */
end

program define Save, eclass
	est local predict "mlogit_p"
	est scalar k_cat    = $S_VYncat  /* # of categories */
	est scalar k_eq     = e(k_cat)-1 /* # of equations */
	est scalar basecat  = $S_VYtmp1  /* base category */
	est scalar ibasecat = $S_VYibas  /* base category number */
	est local baselab : label ($S_VYdepv) `e(basecat)'
					 /* base category label */

/* Label coleq of matrix of categories with equation names. */

	tempname b b1
	mat `b' = e(b)
	local eqlen = colsof(`b')/e(k_eq)
	local i 1
	while `i' <= e(k_cat) {
		if `i' != e(ibasecat) {
			local j = (`i'-cond(`i'<e(ibasecat),1,2))*`eqlen'+1
			mat `b1' = `b'[1,`j'..`j']
			local eqname : coleq `b1'
		}
		else	local eqname = substr(`"`e(baselab)'"',1,8)

		local eqnames `"`eqnames' `"`eqname'"'"'
		local i = `i' + 1
	}

	mat coleq $S_VYtmp2 = `eqnames'

	est matrix cat $S_VYtmp2 /* matrix of categories */

/* Double saves. */

	global S_E_ncat = e(k_cat)
	global S_E_base = e(basecat)
end

program define Footnote
	local base = substr(`"`e(baselab)'"',1,34)
		/* if varname maxlength increases, 34 should be
		   decreased accordingly
		*/
	di in blu `"(Outcome `e(depvar)'==`base' is the "' /*
	*/ "comparison group)"

	if "`e(fpc)'"!="" { di /* newline */ }
end

